# coding: utf-8

"""
    FINBOURNE Access Management API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, constr
from finbourne_access.models.selector_definition import SelectorDefinition

class PolicyTemplatedSelector(BaseModel):
    """
    Templated selector for a policy template  # noqa: E501
    """
    application: constr(strict=True, min_length=1) = Field(..., description="The application that this selector definition applies to")
    tag: constr(strict=True, min_length=1) = Field(..., description="The type of policy that this selector definition applies to")
    selector: SelectorDefinition = Field(...)
    __properties = ["application", "tag", "selector"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PolicyTemplatedSelector:
        """Create an instance of PolicyTemplatedSelector from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of selector
        if self.selector:
            _dict['selector'] = self.selector.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PolicyTemplatedSelector:
        """Create an instance of PolicyTemplatedSelector from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PolicyTemplatedSelector.parse_obj(obj)

        _obj = PolicyTemplatedSelector.parse_obj({
            "application": obj.get("application"),
            "tag": obj.get("tag"),
            "selector": SelectorDefinition.from_dict(obj.get("selector")) if obj.get("selector") is not None else None
        })
        return _obj
